// #pragma link C++ class serialC;

#ifndef hea
#include "header.h"
#endif

typedef map<string, float> StringFloatMap;

std::string operator+(std::string const &a, int b) {
	std::ostringstream oss;
	oss << a << b;
	return oss.str();
}

vector<string> split(const string &s, char delim) {
	vector<string> result;
	stringstream ss(s);
	string item;
	while (getline(ss, item, delim)) {
		result.push_back(item);
	}
	return result;
}

//#include "dict.Cxx"
#include "C_SerialC.cpp"

int main(int argc, char **argv)
{
	TApplication theApp("TestControlBar", &argc, argv);

///////////////////////////////////////////////////////////////////////////			GUI SECTION			/////////////////////////////////////////////////////
#pragma region "Gui building" 
	
	// main frame
	TGMainFrame *fMainFrame1847 = new TGMainFrame(gClient->GetRoot(), 10, 10, kMainFrame | kVerticalFrame);
	//fMainFrame1847->SetName("fMainFrame1847");
	//fMainFrame1847->SetLayoutBroken(kTRUE);

	// composite frame
	TGCompositeFrame *fMainFrame2381 = new TGCompositeFrame(fMainFrame1847, 1114, 674, kVerticalFrame);
	//fMainFrame2381->SetName("fMainFrame2381");
	//fMainFrame2381->SetLayoutBroken(kTRUE);

	// composite frame
	TGCompositeFrame *fMainFrame1911 = new TGCompositeFrame(fMainFrame2381, 960, 588, kVerticalFrame);
	//fMainFrame1911->SetName("fMainFrame1911");
	//fMainFrame1911->SetLayoutBroken(kTRUE);

	// composite frame
	TGCompositeFrame *fMainFrame1444 = new TGCompositeFrame(fMainFrame1911, 958, 584, kVerticalFrame);
	//fMainFrame1444->SetName("fMainFrame1444");
	//fMainFrame1444->SetLayoutBroken(kTRUE);

	// composite frame
	TGCompositeFrame *fMainFrame3725 = new TGCompositeFrame(fMainFrame1444, 1027, 617, kVerticalFrame);
	//fMainFrame3725->SetName("fMainFrame3725");
	//fMainFrame3725->SetLayoutBroken(kTRUE);

	ULong_t ucolor;        // will reflect user color changes
	gClient->GetColorByName("#000000", ucolor);

	// composite frame
	TGCompositeFrame *fMainFrame1076 = new TGCompositeFrame(fMainFrame3725, 962, 584, kVerticalFrame, ucolor);
	//fMainFrame1076->SetName("fMainFrame1076");
	//fMainFrame1076->SetLayoutBroken(kTRUE);

	gClient->GetColorByName("#ccffff", ucolor);

	// tab widget
	TGTab *tabWidget = new TGTab(fMainFrame1076, 958, 576, TGTab::GetDefaultGC()(), TGTab::GetDefaultFontStruct(), kChildFrame, ucolor);

	// container of "Realtime"
	TGCompositeFrame *fCompositeFrame671;
	fCompositeFrame671 = tabWidget->AddTab("Realtime");
	fCompositeFrame671->SetLayoutManager(new TGVerticalLayout(fCompositeFrame671));

	// embedded canvas
	TRootEmbeddedCanvas *realtime = new TRootEmbeddedCanvas(0, fCompositeFrame671, 950, 520, kSunkenFrame, ucolor);
	Int_t wrealtime = realtime->GetCanvasWindowId();
	TCanvas *c133 = new TCanvas("c133", 10, 10, wrealtime);
	realtime->AdoptCanvas(c133);
	fCompositeFrame671->AddFrame(realtime, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));


	// horizontal frame
	TGHorizontalFrame *fHorizontalFrame685 = new TGHorizontalFrame(fCompositeFrame671, 308, 22, kHorizontalFrame, ucolor);

	TGTextButton *RT_Start = new TGTextButton(fHorizontalFrame685, "Enable Real time Graph", -1, TGTextButton::GetDefaultGC()(), TGTextButton::GetDefaultFontStruct(), kRaisedFrame);
	//RT_Start->SetTextJustify(36);
	//RT_Start->SetMargins(0, 0, 0, 0);
	//RT_Start->SetWrapLength(-1);
	//RT_Start->Resize(140, 22);

	//RT_Start->ChangeBackground(ucolor);
	fHorizontalFrame685->AddFrame(RT_Start, new TGLayoutHints(kLHintsNormal));
	TGCheckButton *RT_A0 = new TGCheckButton(fHorizontalFrame685, "A0");

	//RT_A0->ChangeBackground(ucolor);
	//RT_A0->SetTextJustify(36);
	//RT_A0->SetMargins(0, 0, 0, 0);
	//RT_A0->SetWrapLength(-1);
	fHorizontalFrame685->AddFrame(RT_A0, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsCenterY));
	TGCheckButton *RT_A5 = new TGCheckButton(fHorizontalFrame685, "A5");

	//RT_A5->ChangeBackground(ucolor);
	//RT_A5->SetTextJustify(36);
	//RT_A5->SetMargins(0, 0, 0, 0);
	//RT_A5->SetWrapLength(-1);
	fHorizontalFrame685->AddFrame(RT_A5, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsCenterY, 2, 2, 2, 2));
	TGCheckButton *RT_A6 = new TGCheckButton(fHorizontalFrame685, "A6");

	//RT_A6->ChangeBackground(ucolor);
	//RT_A6->SetTextJustify(36);
	//RT_A6->SetMargins(0, 0, 0, 0);
	//RT_A6->SetWrapLength(-1);
	fHorizontalFrame685->AddFrame(RT_A6, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsCenterY, 2, 2, 2, 2));
	TGCheckButton *RT_A7 = new TGCheckButton(fHorizontalFrame685, "A7");

	//RT_A7->ChangeBackground(ucolor);
	//RT_A7->SetTextJustify(36);
	//RT_A7->SetMargins(0, 0, 0, 0);
	//RT_A7->SetWrapLength(-1);
	fHorizontalFrame685->AddFrame(RT_A7, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsCenterY, 2, 2, 2, 2));

	fCompositeFrame671->AddFrame(fHorizontalFrame685, new TGLayoutHints(kLHintsNormal));


	TGTabElement *tab0 = tabWidget->GetTabTab(0);
	tab0->ChangeBackground(ucolor);

	// container of "Oscilloscope"
	TGCompositeFrame *fCompositeFrame692;
	fCompositeFrame692 = tabWidget->AddTab("Oscilloscope");
	fCompositeFrame692->SetLayoutManager(new TGVerticalLayout(fCompositeFrame692));


	// embedded canvas
	TRootEmbeddedCanvas *oscilloscope = new TRootEmbeddedCanvas(0, fCompositeFrame692, 950, 528, kSunkenFrame, ucolor);
	Int_t woscilloscope = oscilloscope->GetCanvasWindowId();
	TCanvas *c134 = new TCanvas("c134", 10, 10, woscilloscope);
	oscilloscope->AdoptCanvas(c134);
	fCompositeFrame692->AddFrame(oscilloscope, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));


	TGTabElement *tab1 = tabWidget->GetTabTab(1);
	tab1->ChangeBackground(ucolor);

	// container of "settings"
	TGCompositeFrame *fCompositeFrame707;
	fCompositeFrame707 = tabWidget->AddTab("settings");
	fCompositeFrame707->SetLayoutManager(new TGVerticalLayout(fCompositeFrame707));

	serialC s(fCompositeFrame707, ucolor);

	// "working options" group frame
	TGGroupFrame *fGroupFrame723 = new TGGroupFrame(fCompositeFrame707, "working options", kVerticalFrame, TGGroupFrame::GetDefaultGC()(), TGGroupFrame::GetDefaultFontStruct(), ucolor);


	// horizontal frame
	TGHorizontalFrame *fHorizontalFrame726 = new TGHorizontalFrame(fGroupFrame723, 436, 50, kHorizontalFrame, ucolor);


	// vertical frame
	TGVerticalFrame *fVerticalFrame727 = new TGVerticalFrame(fHorizontalFrame726, 106, 46, kVerticalFrame, ucolor);

	TGLabel *A0_label = new TGLabel(fVerticalFrame727, "A0", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel728->SetTextJustify(36);
	//fLabel728->SetMargins(0, 0, 0, 0);
	//fLabel728->SetWrapLength(-1);
	fVerticalFrame727->AddFrame(A0_label, new TGLayoutHints(kLHintsLeft | kLHintsCenterX | kLHintsTop, 2, 2, 2, 2));


	// combo box
	TGComboBox *A0_range = new TGComboBox(fVerticalFrame727, -1, kHorizontalFrame | kSunkenFrame | kOwnBackground, ucolor);
	A0_range->Resize(102, 22);
	//A0_range->Select(-1);
	fVerticalFrame727->AddFrame(A0_range, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));

	fHorizontalFrame726->AddFrame(fVerticalFrame727, new TGLayoutHints(kLHintsNormal));


	// vertical frame
	TGVerticalFrame *a5VerticalFrame = new TGVerticalFrame(fHorizontalFrame726, 106, 46, kVerticalFrame, ucolor);

	TGLabel *fLabel741 = new TGLabel(a5VerticalFrame, "A5", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel741->SetTextJustify(36);
	//fLabel741->SetMargins(0, 0, 0, 0);
	//fLabel741->SetWrapLength(-1);
	a5VerticalFrame->AddFrame(fLabel741, new TGLayoutHints(kLHintsLeft | kLHintsCenterX | kLHintsTop, 2, 2, 2, 2));


	// combo box
	TGComboBox *A5_range = new TGComboBox(a5VerticalFrame, -1, kHorizontalFrame | kSunkenFrame | kOwnBackground, ucolor);
	A5_range->Resize(102, 22);
	//A5_range->Select(-1);
	a5VerticalFrame->AddFrame(A5_range, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));

	fHorizontalFrame726->AddFrame(a5VerticalFrame, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));


	// vertical frame
	TGVerticalFrame *fVerticalFrame753 = new TGVerticalFrame(fHorizontalFrame726, 106, 46, kVerticalFrame, ucolor);

	TGLabel *fLabel754 = new TGLabel(fVerticalFrame753, "A6", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel754->SetTextJustify(36);
	//fLabel754->SetMargins(0, 0, 0, 0);
	//fLabel754->SetWrapLength(-1);
	fVerticalFrame753->AddFrame(fLabel754, new TGLayoutHints(kLHintsLeft | kLHintsCenterX | kLHintsTop, 2, 2, 2, 2));


	// combo box
	TGComboBox *A6_range = new TGComboBox(fVerticalFrame753, -1, kHorizontalFrame | kSunkenFrame | kOwnBackground, ucolor);
	A6_range->Resize(102, 22);
	//A6_range->Select(-1);
	fVerticalFrame753->AddFrame(A6_range, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));

	fHorizontalFrame726->AddFrame(fVerticalFrame753, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));


	// vertical frame
	TGVerticalFrame *fVerticalFrame766 = new TGVerticalFrame(fHorizontalFrame726, 106, 46, kVerticalFrame, ucolor);

	TGLabel *fLabel767 = new TGLabel(fVerticalFrame766, "A7", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel767->SetTextJustify(36);
	//fLabel767->SetMargins(0, 0, 0, 0);
	//fLabel767->SetWrapLength(-1);
	fVerticalFrame766->AddFrame(fLabel767, new TGLayoutHints(kLHintsLeft | kLHintsCenterX | kLHintsTop, 2, 2, 2, 2));


	// combo box
	TGComboBox *A7_range = new TGComboBox(fVerticalFrame766, -1, kHorizontalFrame | kSunkenFrame | kOwnBackground, ucolor);
	A7_range->Resize(102, 22);
	//A7_range->Select(-1);
	fVerticalFrame766->AddFrame(A7_range, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));

	fHorizontalFrame726->AddFrame(fVerticalFrame766, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));

	fGroupFrame723->AddFrame(fHorizontalFrame726, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));


	// horizontal frame
	TGHorizontalFrame *fHorizontalFrame779 = new TGHorizontalFrame(fGroupFrame723, 918, 22, kHorizontalFrame, ucolor);

	TGLabel *fLabel780 = new TGLabel(fHorizontalFrame779, "Update (ms)", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel780->SetTextJustify(36);
	//fLabel780->SetMargins(0, 0, 0, 0);
	//fLabel780->SetWrapLength(-1);
	fHorizontalFrame779->AddFrame(fLabel780, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	TGNumberEntry *updateTime = new TGNumberEntry(fHorizontalFrame779, (Double_t)0, 118, -1, (TGNumberFormat::EStyle) 5, (TGNumberFormat::EAttribute) 2);
	fHorizontalFrame779->AddFrame(updateTime, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX));

	fGroupFrame723->AddFrame(fHorizontalFrame779, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX, 2, 2, 2, 2));

	TGTextButton *rangeApply = new TGTextButton(fGroupFrame723, "Apply", -1, TGTextButton::GetDefaultGC()(), TGTextButton::GetDefaultFontStruct(), kRaisedFrame);
	//rangeApply->SetTextJustify(36);
	//rangeApply->SetMargins(0, 0, 0, 0);
	//rangeApply->SetWrapLength(-1);
	//rangeApply->Resize(922, 22);

	//rangeApply->ChangeBackground(ucolor);
	fGroupFrame723->AddFrame(rangeApply, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX));

	TGTextButton *FR_start = new TGTextButton(fGroupFrame723, "Freerun", -1, TGTextButton::GetDefaultGC()(), TGTextButton::GetDefaultFontStruct(), kRaisedFrame);
	//FR_start->SetTextJustify(36);
	//FR_start->SetMargins(0, 0, 0, 0);
	//FR_start->SetWrapLength(-1);
	//FR_start->Resize(922, 22);

	//FR_start->ChangeBackground(ucolor);
	fGroupFrame723->AddFrame(FR_start, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX));

	fGroupFrame723->SetLayoutManager(new TGVerticalLayout(fGroupFrame723));
	//fGroupFrame723->Resize(954, 156);
	fCompositeFrame707->AddFrame(fGroupFrame723, new TGLayoutHints(kLHintsExpandX));


	// "data" group frame
	TGGroupFrame *fGroupFrame785 = new TGGroupFrame(fCompositeFrame707, "data", kVerticalFrame, TGGroupFrame::GetDefaultGC()(), TGGroupFrame::GetDefaultFontStruct(), ucolor);


	// horizontal frame
	TGHorizontalFrame *fHorizontalFrame786 = new TGHorizontalFrame(fGroupFrame785, 918, 26, kHorizontalFrame, ucolor);

	TGLabel *fLabel787 = new TGLabel(fHorizontalFrame786, "Array size", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel787->SetTextJustify(36);
	//fLabel787->SetMargins(0, 0, 0, 0);
	//fLabel787->SetWrapLength(-1);
	fHorizontalFrame786->AddFrame(fLabel787, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	TGNumberEntry *arraySize = new TGNumberEntry(fHorizontalFrame786, (Double_t)0, 6, -1, (TGNumberFormat::EStyle) 5, (TGNumberFormat::EAttribute) 2);
	fHorizontalFrame786->AddFrame(arraySize, new TGLayoutHints(kLHintsRight | kLHintsTop, 2, 2, 2, 2));

	fGroupFrame785->AddFrame(fHorizontalFrame786, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX, 2, 2, 2, 2));


	// horizontal frame
	TGHorizontalFrame *fHorizontalFrame792 = new TGHorizontalFrame(fGroupFrame785, 918, 22, kHorizontalFrame, ucolor);

	TGLabel *fLabel793 = new TGLabel(fHorizontalFrame792, "Sampled size", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel793->SetTextJustify(36);
	//fLabel793->SetMargins(0, 0, 0, 0);
	//fLabel793->SetWrapLength(-1);
	fHorizontalFrame792->AddFrame(fLabel793, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	TGNumberEntry *sampledSize = new TGNumberEntry(fHorizontalFrame792, (Double_t)0, 6, -1, (TGNumberFormat::EStyle) 5, (TGNumberFormat::EAttribute) 2);
	fHorizontalFrame792->AddFrame(sampledSize, new TGLayoutHints(kLHintsRight | kLHintsTop));

	fGroupFrame785->AddFrame(fHorizontalFrame792, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX, 2, 2, 2, 2));


	// horizontal frame
	TGHorizontalFrame *fHorizontalFrame798 = new TGHorizontalFrame(fGroupFrame785, 922, 22, kHorizontalFrame, ucolor);

	TGLabel *fLabel799 = new TGLabel(fHorizontalFrame798, "# of samples", TGLabel::GetDefaultGC()(), TGLabel::GetDefaultFontStruct(), kChildFrame, ucolor);
	//fLabel799->SetTextJustify(36);
	//fLabel799->SetMargins(0, 0, 0, 0);
	//fLabel799->SetWrapLength(-1);
	fHorizontalFrame798->AddFrame(fLabel799, new TGLayoutHints(kLHintsNormal));
	TGNumberEntry *sampleNumber = new TGNumberEntry(fHorizontalFrame798, (Double_t)0, 6, -1, (TGNumberFormat::EStyle) 5, (TGNumberFormat::EAttribute) 2);
	fHorizontalFrame798->AddFrame(sampleNumber, new TGLayoutHints(kLHintsRight | kLHintsTop));

	fGroupFrame785->AddFrame(fHorizontalFrame798, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX));

	fGroupFrame785->SetLayoutManager(new TGVerticalLayout(fGroupFrame785));
	//fGroupFrame785->Resize(954, 110);
	fCompositeFrame707->AddFrame(fGroupFrame785, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX));

	
	TGTabElement *tab2 = tabWidget->GetTabTab(2);
	tab2->ChangeBackground(ucolor);

	//tabWidget->SetTab(1);

	//tabWidget->Resize(tabWidget->GetDefaultSize());
	fMainFrame1076->AddFrame(tabWidget, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
	//tabWidget->MoveResize(2, 2, 958, 576);

	fMainFrame3725->AddFrame(fMainFrame1076, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
	//fMainFrame1076->MoveResize(0, 0, 962, 584);

	fMainFrame1444->AddFrame(fMainFrame3725, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
	//fMainFrame3725->MoveResize(0, 0, 1027, 617);

	fMainFrame1911->AddFrame(fMainFrame1444, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
	//fMainFrame1444->MoveResize(0, 0, 958, 584);

	fMainFrame2381->AddFrame(fMainFrame1911, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
	//fMainFrame1911->MoveResize(0, 0, 960, 588);

	fMainFrame1847->AddFrame(fMainFrame2381, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
	//fMainFrame2381->MoveResize(0, 0, 1114, 674);
	
	fMainFrame1847->SetMWMHints(kMWMDecorAll,
		kMWMFuncAll,
		kMWMInputModeless);
	fMainFrame1847->MapSubwindows();

	fMainFrame1847->Resize(fMainFrame1847->GetDefaultSize());
	fMainFrame1847->MapWindow();
	//fMainFrame1847->Resize(1335, 794);
#pragma endregion

#pragma region "Defining vars and reading files" 
	StringFloatMap resistor;
	resistor["A0"] = resistor["A1"] = resistor["A2"] = resistor["A3"] = resistor["A4"] = resistor["A5"] = resistor["A6"] = resistor["A7"] = 0.;
	resistor["0"] = resistor["1"] = resistor["2"] = resistor["3"] = resistor["4"] = resistor["5"] = resistor["6"] = resistor["7"] = 0.;
	resistor["8"] = resistor["9"] = resistor["10"] = resistor["11"] = resistor["12"] = resistor["13"] = 0.;


	// read resistors from file
	ifstream readFile;
	readFile.open("D:\\resistors.csv");
	if (readFile.is_open()) {
		while (!readFile.eof()) {
			string line;
			getline(readFile, line);
			if (line != ""){
				vector<string> r = split(line, ';');
				if (r[0] == "A0" || r[0] == "A1" || r[0] == "A2" || r[0] == "A3" || r[0] == "A4" || r[0] == "A5" || r[0] == "A6" || r[0] == "A7" ||
					r[0] == "0" || r[0] == "1" || r[0] == "2" || r[0] == "3" || r[0] == "4" || r[0] == "5" || r[0] == "6" || r[0] == "7" ||
					r[0] == "8" || r[0] == "9" || r[0] == "10" || r[0] == "11" || r[0] == "12" || r[0] == "13"){
					resistor[r[0]] = stof(r[1]);
				}
				else {
					cout << "invalid resistors row: " << line << endl;
					theApp.Terminate(2);
				}
			}
		}
		StringFloatMap::iterator pos;
		for (pos = resistor.begin(); pos != resistor.end(); ++pos) {
			if (pos->second == 0){
				cout << "key: \"" << pos->first << " not valid " << endl;
				theApp.Terminate(3);
			}
		}
	}
	else {
		cout << "unable to read resistors.csv" << endl;
		theApp.Terminate(1);
	}
	readFile.close();

	int maxStorage = 100000; // dimensione massima buffer dati
	string comPort = "COM5";

	readFile.open("D:\\settings.csv");
	if (readFile.is_open()) {
		while (!readFile.eof()) {
			string line;
			getline(readFile, line);
			if (line != ""){
				vector<string> r = split(line, ';');
				if (r[0] == "maxStorage"){
					maxStorage = stoi(r[1]);
				}
				else if (r[0] == "comPort"){
					comPort = r[1];
				}
				else {
					cout << "invalid settings row: " << line << endl;
					theApp.Terminate(4);
				}
			}
		}
	}
	else {
		cout << "unable to read settings.csv" << endl;
		theApp.Terminate(5);
	}
	readFile.close();

#pragma endregion
	

	gSystem->ProcessEvents();
	theApp.Run();
}


